#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0
 
from qt import *
import sys,os

class addPathQt3(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		
		self.setCaption(_(u'相关目录设置'))
		layout0=QVBoxLayout(self,10,10)
		
		layout1=QHBoxLayout(None,0,0)
		self.table=QListBox(self)
		self.table.setMinimumWidth(260)
		self.rowNumber=0
		
		layout2=QVBoxLayout(None,10,10)
		self.add=QPushButton(self)
		self.add.setText(_(u'添加...'))
		self.remove=QPushButton(self)
		self.remove.setText(_(u'移除'))
		self.remove.setEnabled(False)
		layout2.addWidget(self.add)
		layout2.addWidget(self.remove)
		layout1.addWidget(self.table)
		layout1.addLayout(layout2)
		
		layout4=QHBoxLayout(None,0,10)
		self.savePath=QLineEdit(self)
		self.savePath.setReadOnly(True)
		self.savePathButton=QPushButton(self)
		self.savePathButton.setText(_(u'保存目录...'))
		layout4.addWidget(self.savePath)
		layout4.addWidget(self.savePathButton)
		
		layout3=QHBoxLayout(None,15,120)
		self.ok=QPushButton(self)
		self.ok.setText(_(u'确定'))
		self.cancel=QPushButton(self)
		self.cancel.setText(_(u'取消'))
		layout3.addWidget(self.ok)
		layout3.addWidget(self.cancel)
		
		layout0.addLayout(layout1)
		layout0.addLayout(layout4)
		layout0.addLayout(layout3)
		
		self.connect(self.ok,SIGNAL("clicked()"),SLOT("accept()"))
		self.connect(self.cancel,SIGNAL("clicked()"),SLOT("reject()"))
		self.connect(self.add,SIGNAL("clicked()"),self.addPath)
		self.connect(self.remove,SIGNAL("clicked()"),self.removePath)
		self.connect(self.table,SIGNAL("highlighted(int)"),self.enableRemove)
		self.connect(self.savePathButton,SIGNAL("clicked()"),self.addSavePath)
		
	def addPath(self):
		path=QFileDialog.getExistingDirectory(os.getenv("HOME"),self,None,_(u'请选择lrc歌词搜索目录'))
		if(path<>u''):
			flag=True
			for i in range(0,self.rowNumber):
				if(self.table.item(i).text()==path):
					flag=False
					break
			if(flag):
				self.insertItem(path)
			else:
				QMessageBox.information(self,_(u'提示'),_(u'该目录已被添加'))
	
	def insertItem(self,path):
		self.table.insertItem(path,self.rowNumber)
		self.rowNumber+=1
	
	def removePath(self):
		row=self.table.currentItem()
		self.table.removeItem(row)
		self.rowNumber-=1
		if(self.table.count()==0):
			self.remove.setEnabled(False)

	def enableRemove(self,e):
		self.remove.setEnabled(True)
	
	def addSavePath(self):
		path=QFileDialog.getExistingDirectory(os.getenv("HOME"),self,None,u'请选择保存歌词目录')
		if(path<>u''):
			if(os.access(str(path.local8Bit()),os.W_OK)):
				self.savePath.setText(path)
			else:
				QMessageBox.information(self,_(u'提示'),_(u'该目录不具备写权限'))
	
def main(args):
	app=QApplication(args)
	win=addPathQt3()
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
	app.exec_loop()

if(__name__=="__main__"):
	main(sys.argv)		
