#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: addPathQt4.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from PyQt4.QtCore import *
from PyQt4.QtGui import *
import sys,os

class addPathQt4(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setWindowTitle(_(u'相关目录设置'))
		
		layout5=QVBoxLayout(None)
		
		layout2=QHBoxLayout(None)
		self.table=QTableWidget(0,1,self)
		self.table.setEditTriggers(QAbstractItemView.NoEditTriggers)
        	self.table.setSelectionBehavior(QAbstractItemView.SelectRows)
		self.table.setSelectionMode(QAbstractItemView.SingleSelection)
		self.table.setMinimumWidth(260)
		title=QStringList()<<_(u'搜索路径')
		self.table.setHorizontalHeaderLabels(title)
		self.table.setColumnWidth(0,240)
		self.rowNumber=0
		
		layout1=QVBoxLayout(None)
		self.add=QPushButton(self)
		self.add.setText(_(u'添加...'))
		self.remove=QPushButton(self)
		self.remove.setText(_(u'移除'))
		self.remove.setEnabled(False)
		self.up=QPushButton(self)
		self.up.setText(_(u'上移'))
		self.up.setEnabled(False)
		self.down=QPushButton(self)
		self.down.setText(_(u'下移'))
		self.down.setEnabled(False)
		layout1.addWidget(self.add)
		layout1.addWidget(self.remove)
		layout1.addWidget(self.up)
		layout1.addWidget(self.down)
		
		layout2.addWidget(self.table)
		layout2.addLayout(layout1)
		
		layout4=QHBoxLayout(None)
		layout4.setContentsMargins(0,15,0,15)
		self.savePath=QLineEdit(self)
		self.savePath.setReadOnly(True)
		self.addSavePath=QPushButton(self)
		self.addSavePath.setText(_(u'保存目录...'))
		layout4.addWidget(self.savePath)
		layout4.addWidget(self.addSavePath)
		
		layout3=QHBoxLayout(None)
		layout3.setSpacing(180)
		layout3.setContentsMargins(30,10,30,10)
		self.ok=QPushButton(self)
		self.ok.setText(_(u'确定'))
		self.cancel=QPushButton(self)
		self.cancel.setText(_(u'取消'))
		layout3.addWidget(self.ok)
		layout3.addWidget(self.cancel)
		
		layout5.addLayout(layout2)
		layout5.addLayout(layout4)
		layout5.addLayout(layout3)
		
		self.setLayout(layout5)
		
		self.connect(self.ok,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancel,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.add,SIGNAL("clicked()"),self.addPath)
		self.connect(self.remove,SIGNAL("clicked()"),self.removePath)
		self.connect(self.up,SIGNAL("clicked()"),self.upAction)
		self.connect(self.down,SIGNAL("clicked()"),self.downAction)
		self.connect(self.table,SIGNAL("cellClicked(int,int)"),self.enableButton)
		self.connect(self.addSavePath,SIGNAL("clicked()"),self.addSavePathAction)
	
	def addPath(self):
		path=QFileDialog.getExistingDirectory(self,_(u'请选择lrc歌词搜索目录'),os.getenv("HOME"))
		if(path<>u''):
			flag=False
			for i in range(0,self.rowNumber):
				if(self.table.item(i,0).text()==path):
					flag=True
			if(flag==False):
				self.insertItem(QTableWidgetItem(path,0))
				self.updownButton(self.table.currentRow())
			else:
				QMessageBox.information(self,_(u'提示'),_(u'该目录已被添加'))
	
	def insertItem(self,item):
		self.rowNumber+=1
		self.table.setRowCount(self.rowNumber)
		self.table.setItem(self.rowNumber-1,0,item)
	
	def removePath(self):
		self.table.removeRow(self.table.currentRow())
		self.rowNumber-=1
		self.updownButton(self.table.currentRow())
	
	def enableButton(self,row,column):
		self.remove.setEnabled(True)
		self.updownButton(row)
	
	def upAction(self):
		row=self.table.currentRow()
		item_column0=self.table.takeItem(row,0)
		tmp_row=row-1
		tmp_column0=self.table.takeItem(tmp_row,0)
		self.table.setItem(row,0,tmp_column0)
		self.table.setItem(tmp_row,0,item_column0)
		self.table.selectRow(tmp_row)
		self.updownButton(tmp_row)
	
	def downAction(self):
		row=self.table.currentRow()
		item_column0=self.table.takeItem(row,0)
		tmp_row=row+1
		tmp_column0=self.table.takeItem(tmp_row,0)
		self.table.setItem(row,0,tmp_column0)
		self.table.setItem(tmp_row,0,item_column0)
		self.table.selectRow(tmp_row)
		self.updownButton(tmp_row)
	
	def addSavePathAction(self):
		path=QFileDialog.getExistingDirectory(self,_(u'请选择保存歌词目录'),os.getenv("HOME"))
		if(path<>u''):
			if(os.access(str(path.toLocal8Bit()),os.W_OK)):
				self.savePath.setText(path)
			else:
				QMessageBox.information(self,_(u'提示'),_(u'该目录不具备写权限'))
		
	def updownButton(self,row):
		if(row==0):
			self.up.setEnabled(False)
		else:
			self.up.setEnabled(True)
		if(row==self.rowNumber-1):
			self.down.setEnabled(False)
		else:
			self.down.setEnabled(True)
		if(row<0):
			self.up.setEnabled(False)
			self.down.setEnabled(False)
			self.remove.setEnabled(False)




def main(args):
	app=QApplication(args)
	win=addPathQt4()
	win.show()
	sys.exit(app.exec_())


if(__name__=="__main__"):
	main(sys.argv)