#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: lrcEditorQt3.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from qt import *
import sys,os,re,commands,s2t
from locale import getdefaultlocale

class lrcEditorQt3(QMainWindow):
	
	def __init__(self,f,e,*args):
		apply(QMainWindow.__init__,(self,)+args)
		self.setIcon(QPixmap('../scripts/lrcShow-II/icon/logo.png'))
		self.setCaption(_(u'lrcShow-II歌词编辑器'))
		self.setMinimumSize(QSize(500,280))
		self.initMenuBar()
		self.initToolBar()
		self.initCenterWidget()
		self.fileName=f
		self.encoder=e
		if(os.path.isfile(f)):
			file=open(f)
			content=unicode(file.read(),e)
			file.close()
			self.lrcArea.setText(content)
		else:
			self.lrcArea.setText(u'[ti:]\n[ar:]\n[al:]\n[by:]')
		
		self.connect(self.quitAction,SIGNAL("activated()"),self,SLOT("close()"))
		self.connect(self.saveAction,SIGNAL("activated()"),self.saveAction_)
		self.connect(self.lrcArea,SIGNAL("textChanged()"),self.saveEnable)
		self.connect(self.saveasAction,SIGNAL("activated()"),self.saveasAction_)
		self.connect(self.lrcArea,SIGNAL("redoAvailable(bool)"),self.redoAction,SLOT("setEnabled(bool)"))
		self.connect(self.lrcArea,SIGNAL("undoAvailable(bool)"),self.undoAction,SLOT("setEnabled(bool)"))
		self.connect(self.redoAction,SIGNAL("activated()"),self.lrcArea,SLOT("redo()"))
		self.connect(self.undoAction,SIGNAL("activated()"),self.lrcArea,SLOT("undo()"))
		self.connect(self.selectallAction,SIGNAL("activated()"),self.lrcArea,SLOT("selectAll()"))
		self.connect(self.lrcArea,SIGNAL("copyAvailable(bool)"),self.copyEnable)
		self.connect(self.copyAction,SIGNAL("activated()"),self.lrcArea,SLOT("copy()"))
		self.connect(self.pasteAction,SIGNAL("activated()"),self.lrcArea,SLOT("paste()"))
		self.connect(self.cutAction,SIGNAL("activated()"),self.lrcArea,SLOT("cut()"))
		self.connect(self.inserttagAction,SIGNAL("activated()"),self.inserttagAction_)
		self.connect(self.cleartagAction,SIGNAL("activated()"),self.cleartagAction_)
		self.connect(self.clearlrcAction,SIGNAL("activated()"),self.clearlrcAction_)
		self.connect(self.clearheadAction,SIGNAL("activated()"),self.clearheadAction_)
		self.connect(self.cutpointAction,SIGNAL("activated()"),self.cutpointAction_)
		self.connect(self.cutspaceAction,SIGNAL("activated()"),self.cutspaceAction_)
		self.connect(self.sttransferAction,SIGNAL("activated()"),self.sttransferAction_)
	
	def sttransferAction_(self):
		p=s2t.s2t(str(self.lrcArea.text().utf8()))
		content=p.transfer()
		self.lrcArea.selectAll()
		self.lrcArea.insert(content.decode('utf8'))
		self.lrcArea.moveCursor(QTextEdit.MoveHome,False)
	
	def cutspaceAction_(self):
		lrc_before=str(self.lrcArea.text().utf8())
		self.lrcArea.selectAll()
		lrc_before=re.sub('^\s{1,}|\s{1,}$','',lrc_before)
		lrc_after=re.sub('\s{0,}\n\s{0,}','\n',lrc_before)
		self.lrcArea.insert(lrc_after.decode('utf8'))
		self.lrcArea.moveCursor(QTextEdit.MoveHome,False)
	
	def cutpointAction_(self):
		lrc_before=str(self.lrcArea.text().utf8())
		self.lrcArea.selectAll()
		lrc_after=re.sub('\.\d\d\]',']',lrc_before)
		self.lrcArea.insert(lrc_after.decode('utf8'))
		self.lrcArea.moveCursor(QTextEdit.MoveHome,False)
	
	def clearheadAction_(self):
		lrc_before=str(self.lrcArea.text().utf8())
		self.lrcArea.selectAll()
		lrc_after=re.sub('\[[a-z,A-Z]{1,}:.*?\]\n','',lrc_before)
		self.lrcArea.insert(lrc_after.decode('utf8'))
		self.lrcArea.moveCursor(QTextEdit.MoveHome,False)
	
	def clearlrcAction_(self):
		self.lrcArea.selectAll()
		self.lrcArea.cut()
	
	def cleartagAction_(self):
		content=str(self.lrcArea.text().utf8())
		self.lrcArea.selectAll()
		content=re.sub('\[\d\d:\d\d.*?\]','',content)
		self.lrcArea.insert(content.decode('utf8'))
		self.lrcArea.moveCursor(QTextEdit.MoveHome,False)
	
	def inserttagAction_(self):
		currentTime=int(commands.getoutput('dcop amarok player trackCurrentTimeMs'))
		munites,ms=divmod(currentTime,60000)
        	if(len(str(ms))==3):
			seconds='00'
		elif(len(str(ms))==4):
                	seconds='0'+str(ms)[0]
        	else:
                	seconds=str(ms)[0:2]
        	mseconds=str(ms)[-3:-1]
        	munites=str(munites)
        	if(len(munites)<>2):
                	munites='0'+munites
        	currentTag='[%s:%s.%s]' %(munites,seconds,mseconds)
		self.lrcArea.insert(currentTag)
        	self.lrcArea.moveCursor(QTextEdit.MoveLineStart,False)
        	self.lrcArea.moveCursor(QTextEdit.MoveDown,False)
	
	def saveasAction_(self):
		filename=QFileDialog.getSaveFileName(self.fileName.decode(getdefaultlocale()[1]),'*.txt *.lrc',self)
		if(str(filename.utf8())<>''):
			content=str(self.lrcArea.text().utf8())
			content=unicode(content,'utf8').encode(self.encoder)
        		file=open(str(filename.local8Bit()),'w')
        		file.write(content)
        		file.close()
        	else:
        		pass
	
	def saveAction_(self):
		content=str(self.lrcArea.text().utf8())
		content=unicode(content,'utf8').encode(self.encoder)
		file=open(self.fileName,'w')
		file.write(content)
		file.close()
		self.saveAction.setEnabled(False)
		
	def saveEnable(self):
		if(os.path.isfile(self.fileName)):
			self.saveAction.setEnabled(True)
		else:
			pass
	
	def copyEnable(self,bool):
		if(bool==True):
			self.copyAction.setEnabled(True)
			self.cutAction.setEnabled(True)
		else:
			self.copyAction.setEnabled(False)
			self.cutAction.setEnabled(False)
	
	def initCenterWidget(self):
		self.lrcArea=QTextEdit(self)
		self.setCentralWidget(self.lrcArea)
	
	def initToolBar(self):
		toolBar=QToolBar(_(u'工具栏'),self)
		
		self.saveAction.addTo(toolBar)
		self.saveasAction.addTo(toolBar)
		self.undoAction.addTo(toolBar)
		self.redoAction.addTo(toolBar)
		self.cutAction.addTo(toolBar)
		self.copyAction.addTo(toolBar)
		self.pasteAction.addTo(toolBar)
		self.cleartagAction.addTo(toolBar)
		self.inserttagAction.addTo(toolBar)
		
		self.addDockWindow(toolBar)
	
	def initMenuBar(self):
		menuBar=self.menuBar()
		
		menuFile=QPopupMenu(self)
		self.saveAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/save.png')),_(u'保存(&S)'),QKeySequence(),self)
		self.saveAction.setEnabled(False)
		self.saveAction.addTo(menuFile)
		self.saveasAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/saveas.png')),_(u'另存为(&A)...'),QKeySequence(),self)
		self.saveasAction.addTo(menuFile)
		self.quitAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/exit.png')),_(u'退出(&Q)'),QKeySequence(),self)
		self.quitAction.addTo(menuFile)
		
		menuEdit=QPopupMenu(self)
		self.undoAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/undo.png')),_(u'撤销(&U)'),QKeySequence(Qt.Key_F6),self)
		self.undoAction.setEnabled(False)
		self.undoAction.addTo(menuEdit)
		self.redoAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/redo.png')),_(u'重做(&D)'),QKeySequence(),self)
		self.redoAction.setEnabled(False)
		self.redoAction.addTo(menuEdit)
		self.cutAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/editcut.png')),_(u'剪切(&X)'),QKeySequence(),self)
		self.cutAction.setEnabled(False)
		self.cutAction.addTo(menuEdit)
		self.copyAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/editcopy.png')),_(u'复制(&C)'),QKeySequence(),self)
		self.copyAction.setEnabled(False)
		self.copyAction.addTo(menuEdit)
		self.pasteAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/editpaste.png')),_(u'粘帖(&P)'),QKeySequence(),self)
		self.pasteAction.addTo(menuEdit)
		self.selectallAction=QAction(QIconSet(),_(u'全选(&A)'),QKeySequence(),self)
		self.selectallAction.addTo(menuEdit)
		
		menuOperation=QPopupMenu(self)
		self.inserttagAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/insert_tag.png')),_(u'插入时间标签(&I)'),QKeySequence(Qt.Key_F5),self)
		self.inserttagAction.addTo(menuOperation)
		self.cleartagAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/del_tags.png')),_(u'清除时间标签(&R)'),QKeySequence(),self)
		self.cleartagAction.addTo(menuOperation)
		self.cutpointAction=QAction(QIconSet(),_(u'清除小数部分(&S)'),QKeySequence(),self)
		self.cutpointAction.addTo(menuOperation)
		self.cutspaceAction=QAction(QIconSet(),_(u'清除多余字符(&P)'),QKeySequence(),self)
		self.cutspaceAction.addTo(menuOperation)
		self.clearlrcAction=QAction(QIconSet(),_(u'清空歌词区(&C)'),QKeySequence(),self)
		self.clearlrcAction.addTo(menuOperation)
		self.clearheadAction=QAction(QIconSet(),_(u'清空LRC头(&H)'),QKeySequence(),self)
		self.clearheadAction.addTo(menuOperation)
		self.sttransferAction=QAction(QIconSet(QPixmap('../scripts/lrcShow-II/icon/st.png')),_(u'简繁体转换(&T)'),QKeySequence(),self)
		self.sttransferAction.addTo(menuOperation)
		
		menuBar.insertItem(_(u'文件(&F)'),menuFile,1,1)
		menuBar.insertItem(_(u'编辑(&E)'),menuEdit,2,2)
		menuBar.insertItem(_(u'操作(&O)'),menuOperation,3,3)
		








def main(args):
	app=QApplication(args)
	win=lrcEditorQt3('/mnt/hda7/Lrc歌词/小情歌 - 苏打绿.lrc','utf8')
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
	app.exec_loop()


if(__name__=="__main__"):
	main(sys.argv)