#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: lrcShow-II.py
# Version:0.7.1
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0
#

import os,sys,commands,gettext,pickle,ConfigParser
from socket import setdefaulttimeout

setdefaulttimeout(15)

def initConfigFile(x):
	c='''[option]
lrcpath=%s,
savelrcpath=%s
download=no
linenumber=3
backroundcolor=57,64,98
fontcolor=255,255,255
highlightcolor=180,200,255
fonttype=serif
fontsize=9
proxy=no
encoder=utf8
searchengine=ttPlayer
nolrc=normal
includecancel=no
autoinsert=no
titlebarinfo=no
completetag=no
[version]
pyqt=%s''' %(os.getenv('HOME'),os.getenv('HOME'),x)
	return c

def mainQt4(args):
	app=QApplication(args)
	win=mainBox()
	thread=myThread(win,app)
	thread.start()
	win.show()
	sys.exit(app.exec_())

def mainQt3(args):
	app=QApplication(args)
	win=mainBox()
	thread=myThread(win,app)
	thread.start()
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
	app.exec_loop()

if(__name__=="__main__"):
	try:
		gettext.translation('lrcShow-II','../scripts/lrcShow-II/locale').install(unicode=True)
	except IOError:
		gettext.translation('lrcShow-II','../scripts/lrcShow-II/locale',languages=['en_US']).install(unicode=True)
	
	if(os.path.exists('lrcShow-II.db')):
		pass
	else:
		mydb=open('lrcShow-II.db','w')
		pickler=pickle.Pickler(mydb,True)
		pickler.dump({})
		mydb.close()
	
	if(os.path.exists('lrcShow-II.conf')):
		pass
	else:
		try:
			from qt import *
		except ImportError:
			try:
				from PyQt4.QtCore import *
				from PyQt4.QtGui import *
			except ImportError:
				os.system('dcop amarok playlist popupMessage "lrcShow-II: you should install pyqt3 or pyqt4 in your system first"')
				sys.exit()
			else:
				config=initConfigFile('4')
				file=open('lrcShow-II.conf','w')
				file.write(config)
				file.close()
				os.system('dcop amarok playlist popupMessage "lrcShow-II: pyqt4 version is working, if you want to switch to pyqt3 version, please install pyqt3 first then use Amarok script manager\'s configure button"')
		else:
			config=initConfigFile('3')
			file=open('lrcShow-II.conf','w')
			file.write(config)
			file.close()
			os.system('dcop amarok playlist popupMessage "lrcShow-II: pyqt3 version is working, if you want to switch to pyqt4 version, please use Amarok script manager\'s configure button"')
	
	p=ConfigParser.ConfigParser()
	p.read('lrcShow-II.conf')
	try:
		a=p.get('version','pyqt')
	except:
		os.system('dcop amarok playlist popupMessage "lrcShow-II: config file error, please check or delete it"')
	else:
		if(a=='3'):
			from qt import *
			from mainGuiQt3 import *
			mainQt3(sys.argv)
		elif(a=='4'):
			from PyQt4.QtCore import *
			from PyQt4.QtGui import *
			from mainGuiQt4 import *
			mainQt4(sys.argv)
		else:
			os.system('dcop amarok playlist popupMessage "lrcShow-II: config file error, please check or delete it"')
