#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: otherSettingQt4.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from PyQt4.QtCore import *
from PyQt4.QtGui import *
import sys,os

class otherSettingQt4(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setWindowTitle(_(u'其它设置'))
		#self.setMinimumSize(320,400)
		MainWindowLayout=QVBoxLayout(None)
		
		layout1=QHBoxLayout(None)
		self.group_hide=group_hide()
		self.group_other=group_other()
		layout1.addWidget(self.group_hide)
		layout1.addWidget(self.group_other)

		
		layout2=QHBoxLayout(None)
		layout2.setSpacing(60)
		layout2.setContentsMargins(80,10,80,10)
		self.okButton=QPushButton(self)
		self.okButton.setText(_(u'确定'))
		
		self.cancelButton=QPushButton(self)
		self.cancelButton.setText(_(u'取消'))
		layout2.addWidget(self.okButton)
		layout2.addWidget(self.cancelButton)
		
		MainWindowLayout.addLayout(layout1)
		MainWindowLayout.addLayout(layout2)
		
		self.setLayout(MainWindowLayout)
		
		self.connect(self.okButton,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancelButton,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.group_hide.normal,SIGNAL("toggled(bool)"),self.normalChecked)
	
	def normalChecked(self,checked):
		if(checked):
			self.group_hide.includeCheckBox.setEnabled(False)
		else:
			self.group_hide.includeCheckBox.setEnabled(True)


class group_hide(QGroupBox):
	
	def __init__(self,*args):
        	apply(QGroupBox.__init__,(self,) + args)
		self.setTitle(_(u'无歌词时窗口行为'))
		mainLayout=QVBoxLayout(None)
		#mainLayout.setAlignment(Qt.AlignCenter)
		
		self.normal=QRadioButton(_(u'窗口无变化'),self)
		self.hide=QRadioButton(_(u'窗口自动隐藏'),self)
		self.mini=QRadioButton(_(u'窗口自动最小化'),self)
		self.includeCheckBox=QCheckBox(self)
		self.includeCheckBox.setText(_(u'包括撤销歌词'))
		
		mainLayout.addWidget(self.normal)
		mainLayout.addWidget(self.hide)
		mainLayout.addWidget(self.mini)
		mainLayout.addWidget(self.includeCheckBox)
		
		self.setLayout(mainLayout)
class group_other(QGroupBox):
	
	def __init__(self,*args):
        	apply(QGroupBox.__init__,(self,) + args)
		self.setTitle(_(u'其它选项'))
		mainLayout=QVBoxLayout(None)
		#mainLayout.setAlignment(Qt.AlignCenter)
		
		self.autoInsert=QCheckBox(self)
		self.autoInsert.setText(_(u'自动插入歌词至Amarok侧边栏'))
		self.autoInsert.setToolTip(_(u'开启此功能，强烈建议您关闭其它Amarok歌词脚本'))
		self.completeTagSearch=QCheckBox(self)
		self.completeTagSearch.setText(_(u'仅标签完整时搜索歌词'))
		self.completeTagSearch.setToolTip(_(u'无标签信息时强制不搜索'))
		self.autoTitleBar=QCheckBox(self)
		self.autoTitleBar.setText(_(u'标题栏显示音轨信息'))
		self.autoTitleBar.setToolTip(_(u'改变此选项后，下个音轨生效；不包括无标签信息的音轨'))
		
		mainLayout.addWidget(self.autoTitleBar)
		mainLayout.addWidget(self.completeTagSearch)
		mainLayout.addWidget(self.autoInsert)
		
		self.setLayout(mainLayout)

def main(args):
	app=QApplication(args)
	win=otherSettingQt4()
	win.show()
	sys.exit(app.exec_())


if(__name__=="__main__"):
	main(sys.argv)
